<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class ImportacaoCatracaController extends \Teknisa\MAN\Controllers\TeknisaCrud {
    protected $importacaoServices;
    
    public function __construct(Services\ImportacaoCatracaServices $importacaoServices) {
        $this->importacaoServices = $importacaoServices;
    }
    
    public function findFilial(DTO\Request\Filter $request, DTO\Response $response){
        $conditions = $request->getFilterCriteria()->getConditions();

        if(isset($conditions) && isset($conditions[0]) && $conditions[0]['columnName'] == 'CDFILIAL'){
            $CDFILIAL = $conditions[0]['value'];
        }else{
            $CDFILIAL = NULL;
        }
        
        if(isset($conditions) && isset($conditions[1]) && $conditions[1]['columnName'] == 'DTIMPORT'){
            $DT = $conditions[1]['value'];
            if(isset($DT[0])){
                $DTINI = $DT[0];
            }else{
                $DTINI = NULL;
            }
            
            if(isset($DT[1])){
                $DTFIN = $DT[1];
            }else{
                $DTFIN = NULL;
            }
        }
        
        if(isset($conditions) && isset($conditions[2]) && $conditions[2]['columnName'] == 'TPCRITICA'){
            $TPCRITICA = $conditions[2]['value'];
        }else{
            $TPCRITICA = NULL;
        }

        $conditions = [
            'IDCRALOGCAT'   =>  NULL,
            'IDCATLOGCAT'   =>  NULL,
            'IDDATLOGCAT'   =>  NULL,
            'IDSERLOGCAT'   =>  NULL,
            'IDDUPLOGCAT'   =>  NULL,
            'IDCRAHABFILI'  =>  NULL,
            'IDPROLOGCAT'   =>  NULL
        ];
        
       $count = sizeof($TPCRITICA);
       
       if($count == 7){
           $conditions['TODOS'] = 'T';
       }else{
           foreach($TPCRITICA as $key => $value){
               $exists = array_key_exists($value, $conditions);
               if($exists){
                   $conditions[$value] = 3;
               }
           }
           $conditions['TODOS'] = NULL;
       }
        
        $conditions['CDFILIAL'] = $CDFILIAL;
        $conditions['DTINI'] = $DTINI;
        $conditions['DTFIN'] = $DTFIN;
        
        $query = $this->importacaoServices->findFilial($conditions);
        
        $response->addDataSet(new DataSet('findLogs', $query));
    }
    
    public function uploadDadosCatraca(DTO\Request\DataSet $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows()[0];
        
        $services = $this->importacaoServices->insertDadosCatraca($rows);
        
        return $services;
    }
    
    public function deleteRowLogCatraca(DTO\Request\DataSet $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows()[0];
        $params = (array)$row;
        $services = $this->importacaoServices->deleteRowLogCatraca($params);
    }
}
