<?php

namespace Teknisa\MAN\Factories;

use Doctrine\DBAL\Connection;

class RelTempoPermanenciaMesaFactory {
    protected $connection;

    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    public function find($params, $cdloja, $nrmesa, $abertura) {
        
        $qry = "
        SELECT ABERMESA, SUM(ACRESCIMO) AS ACRESCIMO, CDCAIXA, CDFILIAL, CDLOJA, DTENTRVENDA_FIELD, FECHMESA, 
            NMMESA, NRMESA, NRPESSOAS, NRSEQVENDA, SUM(TAXASERVICO) AS TAXASERVICO, TEMPOPERMANENCIA, (SUM(VRLIQUIDO)/NRPESSOAS) AS TICKET_MEDIO, VENDEDOR, SUM(VRBRUTO) AS VRBRUTO, SUM(VRLIQUIDO) AS VRLIQUIDO FROM (
            SELECT TAB1.NRMESA, TAB1.NMRAZSOCVEN AS VENDEDOR, TAB1.CDFILIAL, 
                    TAB1.CDLOJA, TAB1.CDCAIXA, TAB1.NRSEQVENDA, 
                    TAB1.NRPESSOAS, TAB1.ABERMESA, TAB1.FECHMESA, 
                    (TAB1.NMMESA || ' | Permanência: ' || (TO_CHAR(TRUNC(NVL(TOTAL.TEMPOPERMANENCIA, 0) / 3600), 'FM9900') || ':' || TO_CHAR(TRUNC(MOD(NVL(TOTAL.TEMPOPERMANENCIA, 0), 3600) / 60), 'FM00') || ':' || TO_CHAR(MOD(NVL(TOTAL.TEMPOPERMANENCIA, 0), 60), 'FM00'))) AS NMMESA, 
                    (TO_CHAR(TRUNC(NVL(TAB1.TEMPOPERMANENCIA, 0) / 3600), 'FM9900') || ':' || TO_CHAR(TRUNC(MOD(NVL(TAB1.TEMPOPERMANENCIA, 0), 3600) / 60), 'FM00') || ':' || TO_CHAR(MOD(NVL(TAB1.TEMPOPERMANENCIA, 0), 60), 'FM00')) AS TEMPOPERMANENCIA, 
                    TAB1.DTENTRVENDA_FIELD, NVL(TAB2.VRGORJETA, 0) AS TAXASERVICO, 
                    (NVL(TAB1.VALOR_VENDIDO, 0) + NVL(TAB1.VRDESCONTO, 0) + NVL(TAB1.VRACRESCIMO, 0)) AS VRBRUTO,
                    (CASE
                        WHEN TAB1.CDPRODUTO = TAB1.CDPRODTXEXCEDE
                            THEN 0
                        ELSE
                            NVL(TAB1.VALOR_VENDIDO, 0) + NVL(TAB1.VRACRESCIMO, 0)
                    END) AS VRLIQUIDO,
                    (CASE
                        WHEN TAB1.CDPRODUTO = TAB1.CDPRODTXEXCEDE
                            THEN  NVL(TAB1.VALOR_TOTAL, 0)
                        ELSE
                            NVL(TAB1.VRACRESCIMO, 0)
                    END) AS ACRESCIMO
                FROM ( 
                    SELECT V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.NRSEQVENDA, V.NRMESA, M.NMMESA, VE.NMRAZSOCVEN, 
                            TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') DTENTRVENDA_FIELD, 
                            TO_CHAR(MIN(ITV.DTHRPEDIDO), 'DD/MM/YYYY HH24:MI:SS') ABERMESA, 
                            TO_CHAR(V.DTHRMESAFECHVEN, 'DD/MM/YYYY HH24:MI:SS') FECHMESA, 
                            ROUND(TO_NUMBER(V.DTHRMESAFECHVEN - MIN(ITV.DTHRPEDIDO)) * 24 * 3600) AS TEMPOPERMANENCIA, 
                            SUM(TRUNC(NVL(I.VRDESITVEND, 0), 2)) AS VRDESCONTO, SUM(TRUNC(NVL(I.VRACRITVEND, 0), 2)) AS VRACRESCIMO,
                            SUM(NVL(I.VRACRITVEND, 0)), I.CDPRODUTO, L.CDPRODTXEXCEDE, 
                            NVL(V.NRPESMESAVENDA, 1) AS NRPESSOAS, 
                            SUM(NVL(V.VRREPIQUEVENDA, 0)) OVER (PARTITION BY V.CDFILIAL, V.CDCAIXA, V.NRSEQVENDA) AS VRREPIQUE, 
                            SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0)) AS VALOR_VENDIDO, 
                            SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VALOR_TOTAL 
                        FROM VENDA V 
                            JOIN ITEMVENDA I 
                                ON V.NRSEQVENDA = I.NRSEQVENDA 
                                    AND V.CDCAIXA = I.CDCAIXA 
                                    AND V.CDFILIAL = I.CDFILIAL 
                            JOIN (
                                SELECT MIN(DTHRPEDIDO) AS DTHRPEDIDO, IH.CDFILIAL, IH.CDCAIXA, IH.NRSEQVENDA 
                                    FROM ITHRCOMANDA IH, VENDA V 
                                    WHERE V.CDFILIAL = IH.CDFILIAL 
                                        AND V.CDCAIXA = IH.CDCAIXA 
                                        AND V.NRSEQVENDA = IH.NRSEQVENDA 
                                    GROUP BY IH.CDFILIAL, IH.CDCAIXA, IH.NRSEQVENDA
                            ) ITV 
                                ON V.CDFILIAL = ITV.CDFILIAL 
                                    AND V.CDCAIXA = ITV.CDCAIXA 
                                    AND V.NRSEQVENDA = ITV.NRSEQVENDA 
                            JOIN LOJA L 
                                ON V.CDFILIAL = L.CDFILIAL 
                                    AND V.CDLOJA = L.CDLOJA 
                            JOIN (
                                SELECT CDFILIAL, CDLOJA, NRMESA, NMMESA 
                                    FROM MESA ME 
                                    WHERE ME.CDFILIAL = :P_CDFILIAL
                                        AND ((ME.CDLOJA IN ($cdloja)) OR (:P_TCDLOJA = 'T')) 
                                        AND ((ME.CDFILIAL||ME.NRMESA IN ($nrmesa)) OR (:P_TNRMESA = 'T'))
                            ) M 
                                ON M.CDFILIAL = L.CDFILIAL 
                                    AND M.CDFILIAL = V.CDFILIAL 
                                    AND M.CDLOJA = V.CDLOJA 
                                    AND M.CDLOJA = L.CDLOJA 
                                    AND M.NRMESA = V.NRMESA 
                            LEFT JOIN VENDEDOR VE 
                                ON V.CDVENDEDOR = VE.CDVENDEDOR 
                        WHERE V.DTENTRVENDA BETWEEN TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY') 
                            AND V.IDSITUVENDA = 'O' 
                            AND I.CDPRODUTO <> NVL(L.CDPRODTAXASERV, 'Z') 
                            AND V.IDORIGEMVENDA LIKE 'MES%' 
                            $abertura
                        GROUP BY V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.NRSEQVENDA, V.NRMESA, 
                                V.DTENTRVENDA, V.DTHRMESAFECHVEN, V.NRMESA, M.NMMESA,
                                VE.NMRAZSOCVEN, V.NRPESMESAVENDA, V.VRREPIQUEVENDA, I.CDPRODUTO, L.CDPRODTXEXCEDE
                ) TAB1 
                    LEFT JOIN (
                        SELECT V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.NRSEQVENDA, 
                                SUM(NVL(I.VRACRITVEND, 0)), 
                                (SUM(TRUNC(NVL(I.QTPRODVEND, 0) * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2)) + SUM(NVL(I.VRACRITVEND, 0))) AS VRGORJETA 
                            FROM VENDA V 
                                JOIN ITEMVENDA I 
                                    ON V.NRSEQVENDA = I.NRSEQVENDA 
                                        AND V.CDCAIXA = I.CDCAIXA 
                                        AND V.CDFILIAL = I.CDFILIAL 
                                JOIN LOJA L 
                                    ON V.CDFILIAL = L.CDFILIAL 
                                        AND V.CDLOJA = L.CDLOJA 
                                JOIN (
                                    SELECT CDFILIAL, CDLOJA, NRMESA, NMMESA 
                                        FROM MESA ME 
                                        WHERE ME.CDFILIAL = :P_CDFILIAL
                                            AND ((ME.CDLOJA IN ($cdloja)) OR (:P_TCDLOJA = 'T'))
                                            AND ((ME.CDFILIAL||ME.NRMESA IN ($nrmesa)) OR (:P_TNRMESA = 'T'))
                                ) M 
                                    ON M.CDFILIAL = L.CDFILIAL 
                                        AND M.CDLOJA = L.CDLOJA 
                                        AND M.NRMESA = V.NRMESA 
                            WHERE I.CDPRODUTO = L.CDPRODTAXASERV 
                                AND L.IDCOMISVENDA IN ('S', 'G') 
                                AND L.IDTRATTAXASERV = 'P' 
                                AND V.DTENTRVENDA BETWEEN TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY') 
                                AND V.IDORIGEMVENDA LIKE 'MES%' 
                                AND V.IDSITUVENDA = 'O' 
                                $abertura
                            GROUP BY V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.NRSEQVENDA, V.NRMESA
                    ) TAB2 
                        ON TAB1.CDFILIAL = TAB2.CDFILIAL 
                            AND TAB1.CDLOJA = TAB2.CDLOJA 
                            AND TAB1.CDCAIXA = TAB2.CDCAIXA 
                            AND TAB1.NRSEQVENDA = TAB2.NRSEQVENDA 
                    JOIN (
                        SELECT L.CDFILIAL, L.CDLOJA, L.NRMESA, SUM(L.TEMPOPERMANENCIA) AS TEMPOPERMANENCIA 
                            FROM (
                                SELECT V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.NRSEQVENDA, V.NRMESA, 
                                        ROUND(TO_NUMBER(V.DTHRMESAFECHVEN - MIN(ITV.DTHRPEDIDO)) * 24 * 3600) AS TEMPOPERMANENCIA 
                                    FROM VENDA V 
                                        JOIN (
                                            SELECT MIN(DTHRPEDIDO) AS DTHRPEDIDO, IH.CDFILIAL, IH.CDCAIXA, IH.NRSEQVENDA 
                                                FROM ITHRCOMANDA IH, VENDA V 
                                                WHERE V.CDFILIAL = IH.CDFILIAL 
                                                    AND V.CDCAIXA = IH.CDCAIXA 
                                                    AND V.NRSEQVENDA = IH.NRSEQVENDA 
                                                GROUP BY IH.CDFILIAL, IH.CDCAIXA, IH.NRSEQVENDA 
                                        ) ITV 
                                            ON V.CDFILIAL = ITV.CDFILIAL 
                                                AND V.CDCAIXA = ITV.CDCAIXA 
                                                AND V.NRSEQVENDA = ITV.NRSEQVENDA 
                                        JOIN (
                                            SELECT CDFILIAL, CDLOJA, CDCAIXA, NMCAIXA 
                                                FROM CAIXA CA 
                                                WHERE CA.CDFILIAL = :P_CDFILIAL
                                                    AND ((CA.CDLOJA IN ($cdloja)) OR (:P_TCDLOJA = 'T')) 
                                        ) C 
                                            ON V.CDFILIAL = C.CDFILIAL 
                                                AND V.CDCAIXA = C.CDCAIXA 
                                        JOIN (
                                            SELECT ME.CDFILIAL, ME.CDLOJA, ME.NRMESA, ME.NMMESA 
                                                FROM MESA ME 
                                                WHERE ME.CDFILIAL = :P_CDFILIAL
                                                    AND ((ME.CDLOJA IN ($cdloja)) OR (:P_TCDLOJA = 'T')) 
                                                    AND ((ME.CDFILIAL||ME.NRMESA IN ($nrmesa)) OR (:P_TNRMESA = 'T')) 
                                        ) M 
                                            ON V.CDFILIAL = M.CDFILIAL 
                                                AND C.CDLOJA = M.CDLOJA 
                                                AND V.NRMESA = M.NRMESA 
                                        LEFT JOIN VENDEDOR VE 
                                            ON VE.CDVENDEDOR = V.CDVENDEDOR 
                                    WHERE V.DTENTRVENDA BETWEEN TO_DATE(:P_DTINICIAL, 'DD/MM/YYYY') AND TO_DATE(:P_DTFINAL, 'DD/MM/YYYY') 
                                        AND V.IDORIGEMVENDA LIKE 'MES%' 
                                        AND V.IDSITUVENDA = 'O' 
                                        $abertura
                                    GROUP BY V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.NRSEQVENDA, 
                                            V.NRMESA, V.DTABERVENDA, V.DTHRMESAFECHVEN 
                            ) L 
                            GROUP BY L.CDFILIAL, L.CDLOJA, L.NRMESA 
                    ) TOTAL 
                        ON TAB1.CDFILIAL = TOTAL.CDFILIAL 
                            AND TAB1.CDLOJA = TOTAL.CDLOJA 
                            AND TAB1.NRMESA = TOTAL.NRMESA
            ORDER BY TAB1.NRMESA
        ) GROUP BY ABERMESA, CDCAIXA, CDFILIAL, CDLOJA, DTENTRVENDA_FIELD, FECHMESA, NMMESA, NRMESA, NRPESSOAS, NRSEQVENDA, TEMPOPERMANENCIA, VENDEDOR
        ";
        
        $result = $this->connection->fetchAll($qry, $params);
        
        return $result;
    }
}